//package com.philips.smartdoor.base.mvvm;
//
//import android.app.ActivityManager;
//import android.content.ComponentName;
//import android.content.Context;
//import android.content.res.Resources;
//import android.os.Bundle;
//import android.os.IBinder;
//import android.text.TextUtils;
//import android.view.MotionEvent;
//import android.view.View;
//import android.view.WindowManager;
//import android.view.inputmethod.InputMethodManager;
//import android.widget.EditText;
//
//import androidx.annotation.Nullable;
//import androidx.databinding.ViewDataBinding;
//import androidx.lifecycle.LifecycleOwner;
//
//import com.blankj.utilcode.util.AdaptScreenUtils;
//import com.blankj.utilcode.util.ScreenUtils;
//import com.kaadas.lock.base.mvvm.BaseMvvmActivity;
//import com.kaadas.lock.base.mvvm.BaseViewModel;
//import com.yowong.smartdoor.MyApplication;
//import com.yowong.smartdoor.utils.smartdoor.AlertDialogUtil;
//import com.yowong.smartdoor.utils.smartdoor.KeyConstants;
//import com.philips.smartdoor.utils.LanguageUtil;
//import com.yowong.smartdoor.utils.smartdoor.LoadingDialog;
//import com.yowong.smartdoor.utils.smartdoor.SPUtils;
//import com.philips.smartdoor.utils.StatusBarUtils;
//
//
//import java.lang.reflect.ParameterizedType;
//import java.lang.reflect.Type;
//import java.util.List;
//
//import io.reactivex.disposables.Disposable;
//
///**
// * 简单介绍一下：mvvm BaseActivity封装
// * author: prophet
// * date: 2022/10/27
// */
//public abstract class BaseActivity<T extends BaseViewModel> extends BaseMvvmActivity implements LifecycleOwner {
//    private LoadingDialog loadingDialog;
//    protected T viewModel;
//    private Disposable grabBindDisposable;
//    private boolean foregroundTag = false;
//    protected AlertDialogUtil dialogUtil;
//
//    @Override
//    protected void onCreate(@Nullable Bundle savedInstanceState) {
//        super.onCreate(savedInstanceState);
//        // TODO: 2023/3/1 解决关闭权限后  app闪退的问题
////        if (savedInstanceState != null) {
////            Intent intent = new Intent(this, PhilipsWelcomeActivity.class);
////            intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
////            startActivity(intent);
////        }
//        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_ADJUST_PAN);
//        initViewModel();
//        getLifecycle().addObserver(viewModel);
//        MyApplication.getInstance().addActivity(this);
////        listenGrabBind();
//        dialogUtil = new AlertDialogUtil();
//        getLifecycle().addObserver(dialogUtil);
//        //第三种方法
//        StatusBarUtils.with(this)
//                .init();
//
//        /**
//         * 开启电量优化
//         */
//        /*if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
//            KeepAliveManager.batteryOptimizations(getApplicationContext());
//        }*/
//        //勾选同意协议后才允许弹出通知
////        boolean showStatementAndTerms = (boolean) SPUtils.getProtect(KeyConstants.SHOW_STATEMENT_AND_TERMS, true);
////        if (!showStatementAndTerms) {
////            startKeepAlive();
////        }
//        init(getBinding(), savedInstanceState);
//        createObserver();
//    }
//
//    /**
//     * 覆载onCreate生命周期
//     */
//    protected abstract void init(ViewDataBinding binding, Bundle savedInstanceState);
//
//    protected abstract void createObserver();
//
//    @Override
//    protected void onResume() {
//        super.onResume();
//        foregroundTag = true;
//    }
//
//    @Override
//    protected void onPause() {
//        super.onPause();
//        foregroundTag = false;
//    }
//
//    @Override
//    protected void initViewModel() {
//        ParameterizedType type = (ParameterizedType) getClass().getGenericSuperclass();
//        if (type != null) {
//            Type[] a = type.getActualTypeArguments();
//            Class<T> tClass = (Class<T>) a[0];
//        viewModel = getActivityScopeViewModel(tClass);
//        }
//    }
//
//    public void showLoading(String Content) {
//        if (loadingDialog == null) {
//            loadingDialog = new LoadingDialog(this);
//        }
//        if (!isFinishing()) {
//            loadingDialog.show(Content);
//        }
//    }
//
//    public void hiddenLoading() {
//        if (loadingDialog != null) {
//            loadingDialog.dismiss();
//        }
//    }
//
//    public void showLoadingNoCancel(String content) {
//        if (loadingDialog == null) {
//            loadingDialog = new LoadingDialog(this);
//        }
//        loadingDialog.setCancelable(false);
//        if (loadingDialog != null) {
//            loadingDialog.dismiss();
//        }
//    }
//
//    /**
//     * 点击输入框之外的地方  hidden软键盘
//     */
//
//    @Override
//    public boolean dispatchTouchEvent(MotionEvent ev) {
//        if (ev.getAction() == MotionEvent.ACTION_DOWN) {
//            // 获得当前得到焦点的View，一般情况下就是EditText（特殊情况就是轨迹求或者实体案件会移动焦点）
//            View v = getCurrentFocus();
//            if (isShouldHideInput(v, ev)) {
//                hideSoftInput(v.getWindowToken());
//            }
//        }
//        return super.dispatchTouchEvent(ev);
//    }
//
//    /**
//     * 根据EditText所在坐标和用户点击的坐标相对比，来判断是否隐藏键盘，因为当用户点击EditText时没必要隐藏
//     *
//     * @param v
//     * @param event
//     * @return
//     */
//    private boolean isShouldHideInput(View v, MotionEvent event) {
//        if (v != null && (v instanceof EditText)) {
//            int[] l = {0, 0};
//            v.getLocationInWindow(l);
//            int left = l[0], top = l[1], bottom = top + v.getHeight(), right = left
//                    + v.getWidth();
//            if (event.getX() > left && event.getX() < right
//                    && event.getY() > top && event.getY() < bottom) {
//                // 点击EditText的事件，忽略它。
//                return false;
//            } else {
//                return true;
//            }
//        }
//        // 如果焦点不是EditText则忽略，这个发生在视图刚绘制完，第一个焦点不在EditView上，和用户用轨迹球选择其他的焦点
//        return false;
//    }
//
//    /**
//     * 多种隐藏软件盘方法的其中一种
//     *
//     * @param token
//     */
//    private void hideSoftInput(IBinder token) {
//        if (token != null) {
//            InputMethodManager im = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
//            im.hideSoftInputFromWindow(token,
//                    InputMethodManager.HIDE_NOT_ALWAYS);
//        }
//    }
//
//    @Override
//    protected void attachBaseContext(Context newBase) {
//        //获取我们存储的语言环境 比如 "en","zh",等等
//        String spLanguage = (String) SPUtils.getProtect(KeyConstants.LANGUAGE_SET_SAVE, "");
//        if (TextUtils.isEmpty(spLanguage)) {
//            super.attachBaseContext(newBase);
//            return;
//        }
//        //attach 对应语言环境下的context
//        super.attachBaseContext(LanguageUtil.attachBaseContext(newBase, spLanguage));
//    }
//
//
//    /**
//     * 启动保活
//     */
////    public void startKeepAlive() {
////        String spLanguage = (String) SPUtils.getProtect(KeyConstants.LANGUAGE_SET, "");
////        if (!TextUtils.isEmpty(spLanguage)) {
////            LanguageUtil.attachBaseContext(this, spLanguage);
////        }
////        String title = String.format(getString(R.string.app_name_notificatoin_title), getString(R.string.app_name));
////        String content = String.format(getString(R.string.app_name_notificatoin_content), getString(R.string.app_name));
////        KeepAliveManager.init(title,
////                content,
////                R.mipmap.ic_launcher);
////        //启动保活服务
////        KeepAliveManager.toKeepAlive(
////                getApplication()
////                , RunMode.HIGH_POWER_CONSUMPTION, title,
////                content,
////                R.mipmap.ic_launcher,
////                new ForegroundNotification(
////                        //定义前台服务的通知点击事件
////                        new ForegroundNotificationClickListener() {
////                            @Override
////                            public void foregroundNotificationClick(Context context, Intent intent) {
////                                LogUtils.d("JOB-->", " foregroundNotificationClick");
//////                                stopKeepAlive();
////                            }
////                        })
////        );
////    }
//
//    //主动启动保活服务
////    public void startKeepAliveSelf() {
////        startKeepAlive();
////    }
//
//    /**
//     * 停止保活
//     */
////    public void stopKeepAlive() {
////        KeepAliveManager.stopWork(getApplication());
////    }
//
//    @Override
//    protected void onDestroy() {
//        MyApplication.getInstance().removeActivity(this);
//        if (grabBindDisposable != null) {
//            grabBindDisposable.dispose();
//            grabBindDisposable = null;
//        }
//        super.onDestroy();
//    }
//
//    @Override
//    public Resources getResources() {
//        if (ScreenUtils.getScreenHeight() >= 2480 && ScreenUtils.getScreenWidth() >= 2200) {
//            return AdaptScreenUtils.adaptHeight(super.getResources(), 667);
//        }
//        return AdaptScreenUtils.adaptWidth(super.getResources(), 375);
//    }
//
////    public void listenGrabBind() {
////        grabBindDisposable = MyApplication.getInstance().listenerGrabBind()
////                .subscribe(aBoolean -> {
////                    if (foregroundTag && !isForeground(MainActivity.class.getSimpleName())) {
////                        Intent intent = new Intent(AbsBaseActivity.this, MainActivity.class);
////                        startActivity(intent);
////                    }
////                });
////    }
//
//    private boolean isForeground(String cla) {
//        if (TextUtils.isEmpty(cla)) {
//            return false;
//        }
//        ActivityManager manager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
//        List<ActivityManager.RunningTaskInfo> list = manager.getRunningTasks(1);
//        if (list != null && list.size() > 0) {
//            ComponentName cpn = list.get(0).topActivity;
//            if (cpn.getClassName().contains(cla)) {
//                return true;
//            }
//        }
//        return false;
//    }
//
//
//}
